# Experiment with Apache Kafka and streaming framework

Measure latency between record insertion in Kafka and Streaming processing using automated timestamping of Kafka messages.

## Frameworks tested
- Kafka Stream
- Flink
- Spark (streaming, Structured Streaming and Continuous Processing

## Versions
- Spark : 2.3.0
- Flink : 1.4.2
- Kafka : 0.11.0.2

## Sources
### Producer
- fr.ippon.kafkaLatency.producer.AlimKafkaSync : Kafka Producer (100 000 messages) : sync API
- fr.ippon.kafkaLatency.producer.AlimKafkaAsync : Kafka Producer (100 000 messages) : Async API

### Consummer
- fr.ippon.kafkaLatency.streaming.KafkaSparkStreaming : Spark streaming consummer
- fr.ippon.kafkaLatency.streaming.KafkaStructuredSpark : Spark Structured streaming consummer
- fr.ippon.kafkaLatency.streaming.KafkaContinuousSpark : Spark Continous processing consummer
- fr.ippon.kafkaLatency.streaming.KafkaStream : Kafka Streams consummer
- fr.ippon.kafkaLatency.streaming.KafkaFlink : Flink consummer

### Utils
- fr.ippon.kafkaLatency.utils.UtilStats : Streaming statistics
- fr.ippon.kafkaLatency.utils.MetricsProducerReporter : Kafka Producer Metrics
- fr.ippon.kafkaLatency.utils.Config : Helper to fetch properties

## Resources
### config.properties :
 - Kafka
    - topic : Kafka topic to use
    - numPartitions : Number of partitions for topic
    - replication : Replication Factor for topic
    - bootstrap.servers: List of Kafka servers

 - Streaming
    - stats.step : Number of message to group before calculate stats 
    - stats.total : Total number of messages
    - max.poll.records : Max records to fetch in Kafka in a micro-batch
    - spark.continuous.interval : Trigger interval in spark continous processing
    - spark.structured.interval : Trigger interval in spark structured streaming
    - spark.streaming.interval : Interval of micro batch

 - data source
    - listPersons.json