package fr.ippon.kafkaLatency.utils;

import fr.ippon.kafkaLatency.streaming.KafkaContinuousSpark;
import org.apache.commons.configuration2.PropertiesConfiguration;
import org.apache.commons.configuration2.builder.FileBasedConfigurationBuilder;
import org.apache.commons.configuration2.builder.fluent.Parameters;
import org.apache.commons.configuration2.ex.ConfigurationException;
import org.apache.log4j.Logger;

public class Config {

    private static final PropertiesConfiguration config;
    private final static Logger logger = Logger.getLogger(KafkaContinuousSpark.class);

    static {
        try {
            FileBasedConfigurationBuilder<PropertiesConfiguration> builder =
                    new FileBasedConfigurationBuilder<PropertiesConfiguration>(PropertiesConfiguration.class)
                            .configure(new Parameters().properties()
                                    .setFileName("config.properties")
                                    .setThrowExceptionOnMissing(true)
                                    .setIncludesAllowed(false));
            config = builder.getConfiguration();

        } catch (ConfigurationException cex) {
            logger.error("Error " + cex.getMessage());
        }
    }

    static public String getProperty(String key) {
        return (String) config.getProperty(key);
    }


    static public Integer getIntProperty(String key)  {
        return Integer.valueOf(getProperty(key));
    }

}
